import java.io.*;
import java.net.*;
import java.util.*;

class TheClient {
	public static void main(String[] args) throws IOException {
		String serverName = "127.0.0.1";
		int serverPort = 4445;
		int packetLength = 64;
		int count = 1;
		byte[] sBuf = new byte[1500];
		byte[] rBuf = new byte[1500];

		if (args.length != 4) {
			System.out.println("usage: java TheClient <ServerName> <ServerPort> <PacketLength> <Count>");
			return;
		}
		serverName = args[0];
		serverPort = new Integer(args[1]).intValue();
		packetLength = new Integer(args[2]).intValue();
		count = new Integer(args[3]).intValue();
		System.out.println("Started: Server=" + serverName + ", Port=" + serverPort + ", packetLength=" + packetLength + ", count=" + count);

		DatagramSocket dSocket = new DatagramSocket();
		InetAddress address = InetAddress.getByName(serverName);
		DatagramPacket sPacket = new DatagramPacket(sBuf, packetLength-42, address, serverPort);
		DatagramPacket rPacket = new DatagramPacket(rBuf, rBuf.length);

		Date startTime = new Date();
		for (int i=0; i<count; i++) {
			dSocket.send(sPacket);
			try {
				dSocket.receive(rPacket);
			} catch(java.io.IOException e) {
				e.printStackTrace();
			}
		}

		Date endTime = new Date();
		System.out.println("Elapsed time: " + (endTime.getTime() - startTime.getTime()) + " milliseconds");
	}
}
